#ifndef APP_PARAMETER_H_
#define APP_PARAMETER_H_

#include "flash.h"
#include "upUartParse.h"


#pragma pack(push, 1)

typedef struct _configInfo {
    uint32_t upWard_Uart_Baud;  //ͨŲ
    uint32_t J1_485_Baud;       //J1_485ͨŲ
    uint32_t J2_485_Baud;       //J2_485ͨŲ
    uint32_t J3_485_Baud;       //J3_485ͨŲ
    uint32_t J4_485_Baud;       //J4_485ͨŲ
    uint32_t J5_0_485_Baud;     //J5_0_485ͨŲ

    uint16_t crc;               //crcУ
} configInfo;

#pragma pack(pop)

void readConfigParameter(void);
void writeConfigParameter(configInfo inConfigInfo);

float getWorkCurrent(void);
void setWorkCurrent(float Curr);
float getWorkVoltage(void);
void setWorkVoltage(float Voltage);
float getTemperature(void);
void setTemperature(float Temperature);
uint32_t getUpWard_Uart_Baud(void);
uint32_t getJ1_485_Baud(void);
uint32_t getJ2_485_Baud(void);
uint32_t getJ3_485_Baud(void);
uint32_t getJ4_485_Baud(void);
uint32_t getJ5_0_485_Baud(void);



#endif