#include "FreeRTOS.h"
#include "task.h"

#include "downUartParse.h"
#include "upUartParse.h"
#include "queueUart.h"

// /* 1Ľ */
// #define tick_1S configTICK_RATE_HZ

// /* ״̬ */
// typedef enum {
//     wait                        = 0,    /* ״̬ʼ״̬ */
//     startFlag,                          /* յ֡ͷ */
//     // address,                            /* 豸ַ */
//     functionCode,                       /* յ */
//     dataLen,                            /* յݳ */
//     crcCheckBitGW,                      /* յУλ */
//     endFlagGW,                          /* յ֡β */
// } uartStateMachine;


/* gw485 */
static uint8_t J1_485RxBuffer[128];
static uint16_t J1_485RxBufferIndex = 0;
static uint8_t J2_485RxBuffer[128];
static uint16_t J2_485RxBufferIndex = 0;
static uint8_t J3_485RxBuffer[128];
static uint16_t J3_485RxBufferIndex = 0;
static uint8_t J4_485RxBuffer[128];
static uint16_t J4_485RxBufferIndex = 0;
static uint8_t J5_0_485RxBuffer[128];
static uint16_t J5_0_485RxBufferIndex = 0;

/* 100ms */
#define delayTick 50
#define maxdataLen 100

/**
  * @brief  J1ڴ
  * @param 
  * @retval
  */
void J1_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J1_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J1_uart6_handle) == 1)
            && (maxdataLen > J1_485RxBufferIndex)) {
        J1_485RxBuffer[J1_485RxBufferIndex++] = uart_dev_in_char(g_J1_uart6_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J1_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + J1_485RxBufferIndex + queueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J1_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        queueUartSendInfo *sendBuff = (queueUartSendInfo *)Buff;
        sendBuff->length = 6 + J1_485RxBufferIndex;        
        sendBuff->data = Buff + sizeof(queueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = 1;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J1_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J1_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J1_485RxBuffer, J1_485RxBufferIndex);

        /* ־ */
        send += J1_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(upward_uart_Queue)) {
            xQueueSend(upward_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        J1_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J2ڴ
  * @param 
  * @retval
  */
void J2_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J2_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J2_uart7_handle) == 1)
            && (maxdataLen > J2_485RxBufferIndex)) {
        J2_485RxBuffer[J2_485RxBufferIndex++] = uart_dev_in_char(g_J2_uart7_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J2_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {

        uint32_t tempLen = 6 + J2_485RxBufferIndex + queueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J2_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);        
        queueUartSendInfo *sendBuff = (queueUartSendInfo *)Buff;
        sendBuff->length = 6 + J2_485RxBufferIndex;        
        sendBuff->data = Buff + sizeof(queueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = 2;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J2_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J2_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J2_485RxBuffer, J2_485RxBufferIndex);

        /* ־ */
        send += J2_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(upward_uart_Queue)) {
            xQueueSend(upward_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        J2_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J3ڴ
  * @param 
  * @retval
  */
void J3_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J3_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J3_usart2_handle) == 1)
            && (maxdataLen > J3_485RxBufferIndex)) {
        J3_485RxBuffer[J3_485RxBufferIndex++] = uart_dev_in_char(g_J3_usart2_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J3_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {

        uint32_t tempLen = 6 + J3_485RxBufferIndex + queueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J3_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);        
        queueUartSendInfo *sendBuff = (queueUartSendInfo *)Buff;
        sendBuff->length = 6 + J3_485RxBufferIndex;        
        sendBuff->data = Buff + sizeof(queueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = 3;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J3_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J3_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J3_485RxBuffer, J3_485RxBufferIndex);

        /* ־ */
        send += J3_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(upward_uart_Queue)) {
            xQueueSend(upward_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }
        
        J3_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J4ڴ
  * @param 
  * @retval
  */
void J4_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J4_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J4_uart8_handle) == 1)
            && (maxdataLen > J4_485RxBufferIndex)) {
        J4_485RxBuffer[J4_485RxBufferIndex++] = uart_dev_in_char(g_J4_uart8_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J4_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {

        uint32_t tempLen = 6 + J4_485RxBufferIndex + queueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J4_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);        
        queueUartSendInfo *sendBuff = (queueUartSendInfo *)Buff;
        sendBuff->length = 6 + J4_485RxBufferIndex;        
        sendBuff->data = Buff + sizeof(queueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = 4;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J4_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J4_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J4_485RxBuffer, J4_485RxBufferIndex);

        /* ־ */
        send += J4_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(upward_uart_Queue)) {
            xQueueSend(upward_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }
        
        J4_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J5_0ڴ
  * @param 
  * @retval
  */
void J5_0_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J5_0_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J5_0_usart3_handle) == 1)
            && (maxdataLen > J5_0_485RxBufferIndex)) {
        J5_0_485RxBuffer[J5_0_485RxBufferIndex++] = uart_dev_in_char(g_J5_0_usart3_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J5_0_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {

        uint32_t tempLen = 6 + J5_0_485RxBufferIndex + queueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J5_0_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);        
        queueUartSendInfo *sendBuff = (queueUartSendInfo *)Buff;
        sendBuff->length = 6 + J5_0_485RxBufferIndex;        
        sendBuff->data = Buff + sizeof(queueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = getConnectPort();

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J5_0_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J5_0_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J5_0_485RxBuffer, J5_0_485RxBufferIndex + 1);

        /* ־ */
        send += J5_0_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(upward_uart_Queue)) {
            xQueueSend(upward_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        J5_0_485RxBufferIndex = 0;
    }
}



