#include "parameter.h"

#pragma pack(push, 1)

typedef struct _parameterInfo {
    float WorkCurrent;          //
    float WorkVoltage;          //ѹ
    float Temperature;          //¶

    uint32_t upWard_Uart_Baud;  //ͨŲ
    uint32_t J1_485_Baud;       //J1_485ͨŲ
    uint32_t J2_485_Baud;       //J2_485ͨŲ
    uint32_t J3_485_Baud;       //J3_485ͨŲ
    uint32_t J4_485_Baud;       //J4_485ͨŲ
    uint32_t J5_0_485_Baud;     //J5_0_485ͨŲ
}parameterInfo;

#pragma pack(pop)

static parameterInfo parameter;

#define startConfigAddr 0x00
#define configSize  (sizeof(configInfo))

/**
  * @brief  ȡļ
  * @param  
  * @retval 
  */
void readConfigParameter(void)
{
    configInfo tempConfig;
    read_Flash((uint8_t *)&tempConfig, startConfigAddr, configSize);

    /* ļУͨ */
    if (tempConfig.crc == checkModebusCrc((uint8_t *)&tempConfig, configSize - 2)) {
        parameter.J1_485_Baud = tempConfig.J1_485_Baud;
        parameter.J2_485_Baud = tempConfig.J2_485_Baud;
        parameter.J3_485_Baud = tempConfig.J3_485_Baud;
        parameter.J4_485_Baud = tempConfig.J4_485_Baud;
        parameter.J5_0_485_Baud = tempConfig.J5_0_485_Baud;
        parameter.upWard_Uart_Baud = tempConfig.upWard_Uart_Baud;
    }

    /* δͨʹĬϲ */
    else {
        parameter.J1_485_Baud = 9600;
        parameter.J2_485_Baud = 9600;
        parameter.J3_485_Baud = 9600;
        parameter.J4_485_Baud = 9600;
        parameter.J5_0_485_Baud = 115200;
        parameter.upWard_Uart_Baud = 115200;
    }
}

/**
  * @brief  дļ
  * @param  inConfigInfo ļ
  * @retval 
  */
void writeConfigParameter(configInfo inConfigInfo)
{    
    write_Flash((uint8_t *)&inConfigInfo, startConfigAddr, configSize);
}

/**
  * @brief  õ
  * @param  
  * @retval 
  */
float getWorkCurrent(void)
{
    return parameter.WorkCurrent;
}

/**
  * @brief  ù
  * @param  
  * @retval 
  */
void setWorkCurrent(float Curr)
{
    parameter.WorkCurrent = Curr;
}

/**
  * @brief  õѹ
  * @param  
  * @retval 
  */
float getWorkVoltage(void)
{
    return parameter.WorkVoltage;
}

/**
  * @brief  ùѹ
  * @param  
  * @retval 
  */
void setWorkVoltage(float Voltage)
{
    parameter.WorkVoltage = Voltage;
}

/**
  * @brief  õ¶
  * @param  
  * @retval 
  */
float getTemperature(void)
{
    return parameter.Temperature;
}

/**
  * @brief  ¶
  * @param  
  * @retval 
  */
void setTemperature(float Temperature)
{
    parameter.Temperature = Temperature;
}

/**
  * @brief  õģͨŲ
  * @param  
  * @retval 
  */
uint32_t getUpWard_Uart_Baud(void)
{
    return parameter.upWard_Uart_Baud;
}

/**
  * @brief  õJ1ͨŲ
  * @param  
  * @retval 
  */
uint32_t getJ1_485_Baud(void)
{
    return parameter.J1_485_Baud;
}

/**
  * @brief  õJ2ͨŲ
  * @param  
  * @retval 
  */
uint32_t getJ2_485_Baud(void)
{
    return parameter.J2_485_Baud;
}

/**
  * @brief  õJ3ͨŲ
  * @param  
  * @retval 
  */
uint32_t getJ3_485_Baud(void)
{
    return parameter.J3_485_Baud;
}

/**
  * @brief  õJ4ͨŲ
  * @param  
  * @retval 
  */
uint32_t getJ4_485_Baud(void)
{
    return parameter.J4_485_Baud;
}

/**
  * @brief  õJ5_0ͨŲ
  * @param  
  * @retval 
  */
uint32_t getJ5_0_485_Baud(void)
{
    return parameter.J5_0_485_Baud;
}