
#include "queueUart.h"
#include "uart_dev.h"
#include "busIdleDetection.h"
#include "semphr.h"

/* ÿϢĴС */
#define QUEUE_SIZE 4

/* ͨѶڵĶ */
QueueHandle_t J1_485_Queue = NULL;
QueueHandle_t J2_485_Queue = NULL;
QueueHandle_t J3_485_Queue = NULL;
QueueHandle_t J4_485_Queue = NULL;
QueueHandle_t J5_0_485_Queue = NULL;
QueueHandle_t upward_uart_Queue = NULL;
/* м */
QueueSetHandle_t uart_Queue = NULL;

QueueSetMemberHandle_t xActivatedMemberUartQueue;

/* ͨýṹնӦͣͨýṹ壬ͷݵڴ */
typedef struct _queueRecvDataInfo {
    queueUartSendInfo *J1_485_data;
    queueUartSendInfo *J2_485_data;
    queueUartSendInfo *J3_485_data;
    queueUartSendInfo *J4_485_data;
    queueUartSendInfo *upward_uart_data;
    queueTimeShareSendInfo *J5_0_485_data;
} queueRecvDataInfo;
static queueRecvDataInfo queueRecvData;

/**
  * @brief  ʼڷ͵Ķ
  * @param  
  * @retval 
  */
void uartQueueInit(void)
{
    /* ʼ */
    J1_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J1_485_Queue) {
    //     log_error("creat J1_485_Queue error\n");
    // }

    J2_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J2_485_Queue) {
    //     log_error("creat J2_485_Queue error\n");
    // }
    
    J3_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J3_485_Queue) {
    //     log_error("creat J3_485_Queue error\n");
    // }
    
    J4_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J4_485_Queue) {
    //     log_error("creat J4_485_Queue error\n");
    // }
    
    J5_0_485_Queue = xQueueCreate(10, QUEUE_SIZE);
    // if (NULL == J5_0_485_Queue) {
    //     log_error("creat J5_0_485_Queue error\n");
    // }
    
    upward_uart_Queue = xQueueCreate(10, QUEUE_SIZE);
    // if (NULL == upward_uart_Queue) {
    //     log_error("creat upward_uart_Queue error\n");
    // }
    

    /* жм */
    uart_Queue = xQueueCreateSet(6);
    xQueueAddToSet(J1_485_Queue, uart_Queue);
    xQueueAddToSet(J2_485_Queue, uart_Queue);
    xQueueAddToSet(J3_485_Queue, uart_Queue);
    xQueueAddToSet(J4_485_Queue, uart_Queue);
    xQueueAddToSet(J5_0_485_Queue, uart_Queue);
    xQueueAddToSet(upward_uart_Queue, uart_Queue);
}

/**
  * @brief  Ӷȡݣͺ
  * @param  
  * @retval 
  */
void uartQueueSend(void)
{
    /* жǷʱ */
    static uint8_t flag = 0;

    /* 鿴мǷ */
    xActivatedMemberUartQueue = xQueueSelectFromSet(uart_Queue, portMAX_DELAY);

    /* 鿴Upward_uart5 */
    if (!getUartState(g_Upward_uart5_handle)) {
        /* յ */
        if (xQueueReceive(upward_uart_Queue, &queueRecvData.upward_uart_data, 0) == pdTRUE) {
            uartInterruptSend(g_Upward_uart5_handle, queueRecvData.upward_uart_data->data
                    , queueRecvData.upward_uart_data->length);
            flag = 1;
        }
    }

    /* 鿴J1_485 */
    if (!getRs485State(g_J1_uart6_handle)) {
        /* յ */
        if (xQueueReceive(J1_485_Queue, &queueRecvData.J1_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J1_uart6_handle, queueRecvData.J1_485_data->data
                    , queueRecvData.J1_485_data->length);
            flag = 1;
        }
    }

    /* 鿴J2_485 */
    if (!getRs485State(g_J2_uart7_handle)) {
        /* յ */
        if (xQueueReceive(J2_485_Queue, &queueRecvData.J2_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J2_uart7_handle, queueRecvData.J2_485_data->data
                    , queueRecvData.J2_485_data->length);
            flag = 1;
        }
    }

    /* 鿴J3_485 */
    if (!getRs485State(g_J3_usart2_handle)) {
        /* յ */
        if (xQueueReceive(J3_485_Queue, &queueRecvData.J3_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J3_usart2_handle, queueRecvData.J3_485_data->data
                    , queueRecvData.J3_485_data->length);
            flag = 1;
        }
    }

    /* 鿴J4_485 */
    if (!getRs485State(g_J4_uart8_handle)) {
        /* յ */
        if (xQueueReceive(J4_485_Queue, &queueRecvData.J4_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J4_uart8_handle, queueRecvData.J3_485_data->data
                    , queueRecvData.J4_485_data->length);
            flag = 1;
        }
    }
    
    /* 鿴J5_0_485 */
    if (!getRs485State(g_J5_0_usart3_handle)) {
        /* յ */
        if (xQueueReceive(J5_0_485_Queue, &queueRecvData.J5_0_485_data, 0) == pdTRUE) {
            setConnectPort(queueRecvData.J5_0_485_data->connectPort);
            // log_info("send J5_0 Data : %s , %d\n", queueRecvData.J5_0_485_data->data, queueRecvData.J5_0_485_data->length);
            uartInterruptSend(g_J5_0_usart3_handle, queueRecvData.J5_0_485_data->data
                    , queueRecvData.J5_0_485_data->length);
            flag = 1;
        }
    }

    /* ûݷʱ */
    if (!flag) {
        /* ʱϵͳ */
        vTaskDelay(3);
        log_info("getRs485State : %d\n", getRs485State(g_J5_0_usart3_handle));
    }
    flag = 0;
}

#ifdef UARTINTERRUPTSEND


// м
QueueSetHandle_t BinarySemaphoreSet = NULL;
// ֵź
SemaphoreHandle_t J1_BinarySemaphore = NULL;
SemaphoreHandle_t J2_BinarySemaphore = NULL;
SemaphoreHandle_t J3_BinarySemaphore = NULL;
SemaphoreHandle_t J4_BinarySemaphore = NULL;
SemaphoreHandle_t J5_0_BinarySemaphore = NULL;
SemaphoreHandle_t upward_BinarySemaphore = NULL;

/**
  * @brief  ֵźʼͬжϷϢͷڴ
  * @param  
  * @retval 
  */
void binarySemaphoreInit(void)
{
    // ʼм
    BinarySemaphoreSet = xQueueCreateSet(6);

    // ʼֵź
    J1_BinarySemaphore = xSemaphoreCreateBinary();
    J2_BinarySemaphore = xSemaphoreCreateBinary();
    J3_BinarySemaphore = xSemaphoreCreateBinary();
    J4_BinarySemaphore = xSemaphoreCreateBinary();
    J5_0_BinarySemaphore = xSemaphoreCreateBinary();
    upward_BinarySemaphore = xSemaphoreCreateBinary();

    // ֵźӵм
    xQueueAddToSet(J1_BinarySemaphore, BinarySemaphoreSet);
    xQueueAddToSet(J2_BinarySemaphore, BinarySemaphoreSet);
    xQueueAddToSet(J3_BinarySemaphore, BinarySemaphoreSet);
    xQueueAddToSet(J4_BinarySemaphore, BinarySemaphoreSet);
    xQueueAddToSet(J5_0_BinarySemaphore, BinarySemaphoreSet);
    xQueueAddToSet(upward_BinarySemaphore, BinarySemaphoreSet);
}

/**
  * @brief  ֵͨźͷжϷݵڴ
  * @param  
  * @retval 
  */
void binarySemaphoreFreeMemory(void)
{
    // ȴме¼
    QueueSetMemberHandle_t xActivatedMember = xQueueSelectFromSet(BinarySemaphoreSet, portMAX_DELAY);

    if (xActivatedMember == J1_BinarySemaphore) {
        // ִ߼
        vPortFree(queueRecvData.J1_485_data);
        vTaskDelay(1);
        readJ1_485;
        setJ1_485_SendState(0);
        // ֵź¼
        xSemaphoreTake(J1_BinarySemaphore, 0);
    }

    else if (xActivatedMember == J2_BinarySemaphore) {
        vPortFree(queueRecvData.J2_485_data);
        vTaskDelay(1);
        readJ2_485;
        setJ2_485_SendState(0);
        xSemaphoreTake(J2_BinarySemaphore, 0);
    }

    else if (xActivatedMember == J3_BinarySemaphore) {
        vPortFree(queueRecvData.J3_485_data);
        vTaskDelay(1);
        readJ3_485;
        setJ3_485_SendState(0);
        xSemaphoreTake(J3_BinarySemaphore, 0);
    }

    else if (xActivatedMember == J4_BinarySemaphore) {
        vPortFree(queueRecvData.J4_485_data);
        vTaskDelay(1);
        readJ4_485;
        setJ4_485_SendState(0);
        xSemaphoreTake(J4_BinarySemaphore, 0);
    }
    
    else if (xActivatedMember == J5_0_BinarySemaphore) {
        vPortFree(queueRecvData.J5_0_485_data);
        vTaskDelay(1);
        readJ5_0_485;
        setJ5_0_485_SendState(0);
        xSemaphoreTake(J5_0_BinarySemaphore, 0);
    }

    else if (xActivatedMember == upward_BinarySemaphore) {
        vPortFree(queueRecvData.upward_uart_data);
        setUpward_uart_SendState(0);
        xSemaphoreTake(upward_BinarySemaphore, 0);
    }
}

/**
  * @brief  ݷɺ
  * @param  
  * @retval 
  */
void J1_485_IN_TXE(void)
{
    // vPortFree(queueRecvData.J1_485_data);
    xSemaphoreGiveFromISR(J1_BinarySemaphore, 0);
}


void J2_485_IN_TXE(void)
{
    // vPortFree(queueRecvData.J2_485_data);
    xSemaphoreGiveFromISR(J2_BinarySemaphore, 0);
}


void J3_485_IN_TXE(void)
{
    // vPortFree(queueRecvData.J3_485_data);
    xSemaphoreGiveFromISR(J3_BinarySemaphore, 0);
}


void J4_485_IN_TXE(void)
{
    // vPortFree(queueRecvData.J4_485_data);
    xSemaphoreGiveFromISR(J4_BinarySemaphore, 0);
}


void J5_0_485_IN_TXE(void)
{
    // vPortFree(queueRecvData.J5_0_485_data);
    xSemaphoreGiveFromISR(J5_0_BinarySemaphore, 0);
}


void Upward_USART_IN_TXE(void)
{
    // vPortFree(queueRecvData.upward_uart_data);
    xSemaphoreGiveFromISR(upward_BinarySemaphore, 0);
}

#endif
